<?php
/*
Plugin Name: Clean Up Users
Plugin URI: http://www.wordpressplugins.ru/administration/clean-up-users.html
Description: Удаляет неактивных подписчиков (отсутствуют и посты и комменты).
Author: Dagon Design (исправленная версия: Flector)
Version: 1.00 (исправленная для работы на MySQL4)
Author URI: http://www.wordpressplugins.ru/
*/


$ddcuu_version = '1.0';


function ddcuu_add_options_pages() {
	if (function_exists('add_options_page')) {
		add_options_page("Clean Up Users", 'DDCleanUpUsers', 8, __FILE__, 'ddcuu_options_page');
	}		
}

function get_usernumcomments2($userid) { 
global $wpdb; 
$userid = (int) $userid; 
$count = $wpdb->get_var( $wpdb->prepare("SELECT COUNT(*) FROM $wpdb->comments WHERE user_id = %d AND comment_approved = '1'", $userid)); 
return apply_filters('get_usernumcomments2', $count, $userid); 
} 

function get_userrole($userid) { 
	global $wpdb;
	$userid = (int) $userid; 
	$count = (int) $count; 
	$count = $wpdb->get_var( $wpdb->prepare("SELECT user_id FROM $wpdb->usermeta WHERE user_id = %d AND meta_key = 'wp_capabilities' AND meta_value RLIKE 'subscriber'", $userid)); 
	return $count; 
} 

function ddcuu_options_page() {

	global $wpdb, $dddu_version;
	$tp = $wpdb->prefix;
	$result = "";

	if (isset($_POST['info_update'])) {

		// start processing

		?><div id="message" class="updated fade"><p><strong><?php 
		echo "Операция закончена - результат вы можете видеть ниже";
	    ?></strong></p></div><?php

		$result = '';
		$dddu_confirm = (bool)$_POST['dddu_confirm'];
		$temp = 0;

		if ($dddu_confirm) {

			// list of users with no posts and no comments
			$userlist = (array)$wpdb->get_results("
				SELECT {$tp}users.ID  FROM `{$tp}users`
			");

			foreach ($userlist as $u) {
			$userdata = get_userdata( $u->ID );
			$numposts = get_usernumposts( $u->ID );
			$numcomments = get_usernumcomments2( $u->ID ); 
			
			$role_name = get_userrole( $u->ID );
			if ($role_name == $u->ID) {
				$role_name = 'Подписчик';
			} else { $role_name = 'Автор или выше'; }
			//echo $userdata->user_login . '(ID=' . $userdata->ID . '), комменты: ' . $numcomments . ', посты: ' . $numposts . ', роль: ' . $role_name . '. <br>';
			if ($role_name == 'Подписчик' AND $numcomments == 0 AND $numposts == 0) {
				wp_delete_user($u->ID);
				$temp = $temp + 1;
				//echo $userdata->user_login . ' <br>';
			}

			}

			$result = 'Удалено неактивных подписчиков: ' . $temp;
			
		} else {
			$result = 'Поставьте галочку, если действительно хотите удалить неактивных подписчиков!';
		}

		// end processing

	} ?>

	<div class=wrap>

	<h2>Clean Up Users v1.00 (исправленная для работы на MySQL4)</h2>

	<p>Если возникли какие-то вопросы или уточнения прошу посетить:<br />
	<a href="http://www.wordpressplugins.ru/administration/clean-up-users.html">http://www.wordpressplugins.ru/administration/clean-up-users.html</a></p>

	<?php 

	if ($result != "") { 
		echo '<div style="border: 1px solid #888888; padding: 5px;">';
		echo '<strong>Результат</strong>:<br /> ' . trim($result) . '</div>';
	} 

	?>


	<form enctype="multipart/form-data" method="post" action="<?php echo $_SERVER["REQUEST_URI"]; ?>"  >
	<input type="hidden" name="info_update" id="info_update" value="true" />


	<div style="padding: 0 0 15px 12px;">

		<?php print $formatinfo; ?>
		<h3>Опции</h3>
		<input type="checkbox" name="dddu_confirm" id="dddu_confirm" /> 
		Удаление неактивных подписчиков (отсутствуют и посты и комменты).
	</div>


	<div class="submit">
		<input type="submit" name="info_update" value=" Удалить " />
	</div>
	</form>
	</div><?php
}


add_action('admin_menu', 'ddcuu_add_options_pages');

?>